Imports Microsoft.HomeServer.Extensibility
Imports Microsoft.HomeServer.Controls
Imports Microsoft.HomeServer.Common.Client

Public Class MainTabUserControl

    Dim m_consoleServices As IConsoleServices

    Public Sub New()

        ' This call is required by the Windows Form Designer.
        InitializeComponent()

        ' Add any initialization after the InitializeComponent() call.

    End Sub

    Public Sub New(ByVal width As Integer, ByVal height As Integer, ByVal consoleServices As IConsoleServices)
        Me.New()

        Me.Width = width
        Me.Height = height
        Me.m_consoleServices = consoleServices
    End Sub

    Private Sub MainTabUserControl_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'Create item
        Dim redItem As New MessageListBoxItem(Color.Red)
        'Set bold title text
        redItem.Title = "Big ole problem"
        'Set body text
        redItem.Description.Text = "Important information on the specifics of this error goes here."
        'Set icon
        redItem.Icon = CommonImages.StatusCritical24Icon
        'Specify text of button (to make visible)
        redItem.ActionButton.Text = "Fix Error"
        'Add event handler for button
        AddHandler redItem.ActionButton.Click, AddressOf ActionButton_Click
        'Add MessageListBoxItem to MessageListBox
        MessageListBox1.Items.Add(redItem)


        'Create item
        Dim yellowItem As New MessageListBoxItem(Color.Yellow)
        'Set bold title text
        yellowItem.Title = "Minor issue"
        'Set body text
        yellowItem.Description.Text = "The world is going to end... just not today."
        'Set icon
        yellowItem.Icon = CommonImages.StatusAtRisk24Icon
        'Backup current color for use in event handler
        yellowItem.Tag = yellowItem.GradientColor
        'Specify text for CheckBox
        yellowItem.CheckBox.Text = "Ignore this"
        'Make CheckBox visible
        yellowItem.CheckBox.Visible = True
        'Add event handler
        AddHandler yellowItem.CheckBox.CheckedChanged, AddressOf CheckBox_CheckedChanged
        'Add MessageListBoxItem to MessageListBox
        MessageListBox1.Items.Add(yellowItem)


        'Create item
        Dim greenItem As New MessageListBoxItem(Color.Green)
        'Set bold title text
        greenItem.Title = "All is well"
        'Set body text
        greenItem.Description.Text = "Pay no attention to the man behind the curtain." + ControlChars.Lf + "Click here for more information"
        'Set icon
        greenItem.Icon = CommonImages.StatusHealthy24Icon
        'Link starts on 48th character and is 31 character long
        greenItem.Description.LinkArea = New LinkArea(48, 31)
        'Add event handler
        AddHandler greenItem.Description.LinkClicked, AddressOf Description_LinkClicked
        'Add MessageListBoxItem to MessageListBox
        MessageListBox1.Items.Add(greenItem)



        'Create extra item to show off ugliness of having both a button and CheckBox on a single item
        Dim uglyYellowItem As New MessageListBoxItem(Color.Yellow)
        'Set bold title text
        uglyYellowItem.Title = "Minor issue"
        'Set body text
        uglyYellowItem.Description.Text = "The world is going to end... just not today."
        'Set icon
        uglyYellowItem.Icon = CommonImages.StatusAtRisk24Icon

        'Backup current color for use in event handler
        uglyYellowItem.Tag = uglyYellowItem.GradientColor
        'Specify text for CheckBox
        uglyYellowItem.CheckBox.Text = "Ignore this"
        'Make CheckBox visible
        uglyYellowItem.CheckBox.Visible = True
        'Add event handler
        AddHandler uglyYellowItem.CheckBox.CheckedChanged, AddressOf CheckBox_CheckedChanged

        'Specify text of button (to make visible)
        uglyYellowItem.ActionButton.Text = "Fix Error"
        'Add event handler for button
        AddHandler uglyYellowItem.ActionButton.Click, AddressOf ActionButton_Click

        'Add MessageListBoxItem to MessageListBox
        MessageListBox1.Items.Add(uglyYellowItem)
    End Sub

    Sub ActionButton_Click(ByVal sender As Object, ByVal e As EventArgs)
        'Determine which button was clicked
        Dim b As Button = CType(sender, Button)
        'Determine which MessageListBoxItem the button exists on
        Dim mlbi As MessageListBoxItem = CType(b.Parent, MessageListBoxItem)

        'Do useful processing

        'Remove specified MessageListBoxItem from MessageListBox
        MessageListBox1.Items.Remove(mlbi)
    End Sub

    Sub CheckBox_CheckedChanged(ByVal sender As Object, ByVal e As EventArgs)
        'Determine which CheckBox was checked
        Dim cb As CheckBox = CType(sender, CheckBox)
        '//Determine which MessageListBoxItem the CheckBox exists on
        Dim mlbi As MessageListBoxItem = CType(cb.Parent, MessageListBoxItem)
        'Has the checkbox been unchecked? Undo changes and restore color to original
        If (Not mlbi.CheckBox.Checked) Then
            'Do useful processing
            mlbi.GradientColor = CType(mlbi.Tag, Color)
        Else ' Else do disabling work and set color to Gray
            'Do useful processing
            mlbi.GradientColor = Color.Gray
        End If
    End Sub

    Sub Description_LinkClicked(ByVal sender As Object, ByVal e As LinkLabelLinkClickedEventArgs)
        'Do something based on link

        QMessageBox.Show("Link Clicked", "Link Clicked")
    End Sub

    Sub addCriticalItemButton_Click(ByVal sender As Object, ByVal e As EventArgs) Handles addCriticalItemButton.Click
        'Create item
        Dim redItem As New MessageListBoxItem(Color.Red)
        'Set bold title text
        redItem.Title = "Big ole problem"
        'Set body text
        redItem.Description.Text = "Important information on the specifics of this error goes here."
        'Set icon
        redItem.Icon = CommonImages.StatusCritical24Icon
        'Specify text of button (to make visible)
        redItem.ActionButton.Text = "Fix Error"
        'Add event handler for button
        AddHandler redItem.ActionButton.Click, AddressOf ActionButton_Click
        'Add MessageListBoxItem to MessageListBox
        MessageListBox1.Items.Add(redItem)
    End Sub
End Class
